Loading...
Searching...
No Matches
pcl::people::HOG Class Reference

HOG represents a class for computing the HOG descriptor described in Dalal, N. More...

`#include <pcl/people/hog.h>`

## Public Member Functions

| HOG ()
| Constructor.
virtual | ~HOG ()
| Destructor.
void | gradMag (float *I, int h, int w, int d, float *M, float *O) const
| Compute gradient magnitude and orientation at each location (uses sse).
void | gradHist (float *M, float *O, int h, int w, int bin_size, int n_orients, bool soft_bin, float *H) const
| Compute n_orients gradient histograms per bin_size x bin_size block of pixels.
void | normalization (float *H, int h, int w, int bin_size, int n_orients, float clip, float *G) const
| Normalize histogram of gradients.
void | compute (float *I, int h, int w, int n_channels, int bin_size, int n_orients, bool soft_bin, float *descriptor)
| Compute HOG descriptor.
void | compute (float *I, float *descriptor) const
| Compute HOG descriptor with default parameters.

## Protected Attributes

int | h_
| image height (default = 128)
int | w_
| image width (default = 64)
int | n_channels_
| image number of channels (default = 3)
int | bin_size_
| spatial bin size (default = 8)
int | n_orients_
| number of orientation bins (default = 9)
bool | soft_bin_
| if true, each pixel can contribute to multiple spatial bins (using bilinear interpolation) (default = true)
float | clip_
| value at which to clip histogram bins (default = 0.2)

## Detailed Description

HOG represents a class for computing the HOG descriptor described in Dalal, N.

and Triggs, B., "Histograms of oriented gradients for human detection", CVPR 2005.

Author
  Matteo Munaro, Stefano Ghidoni, Stefano Michieletto

Definition at line 54 of file hog.h.

## Constructor & Destructor Documentation

## HOG()

pcl::people::HOG::HOG | ( |  | ) |

Constructor.

## ~HOG()

virtual pcl::people::HOG::~HOG | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## compute() [1/2]

void pcl::people::HOG::compute | ( | float * | I,
|  | float * | descriptor
| ) |  | const

Compute HOG descriptor with default parameters.

Parameters

  [in] | I | Image as array of float between 0 and 1.
  [out] | descriptor | HOG descriptor.

## compute() [2/2]

void pcl::people::HOG::compute | ( | float * | I,
|  | int | h,
|  | int | w,
|  | int | n_channels,
|  | int | bin_size,
|  | int | n_orients,
|  | bool | soft_bin,
|  | float * | descriptor
| ) |  |

Compute HOG descriptor.

Parameters

  [in] | I | Image as array of float between 0 and 1.
  [in] | h | Image height.
  [in] | w | Image width.
  [in] | n_channels | Image number of channels.
  [in] | bin_size | Spatial bin size.
  [in] | n_orients | Number of orientation bins.
  [in] | soft_bin | If true, each pixel can contribute to multiple spatial bins (using bilinear interpolation).
  [out] | descriptor | HOG descriptor.

Referenced by pcl::people::PersonClassifier< PointT >::evaluate().

## gradHist()

void pcl::people::HOG::gradHist | ( | float * | M,
|  | float * | O,
|  | int | h,
|  | int | w,
|  | int | bin_size,
|  | int | n_orients,
|  | bool | soft_bin,
|  | float * | H
| ) |  | const

Compute n_orients gradient histograms per bin_size x bin_size block of pixels.

Parameters

  [in] | M | Gradient magnitude for each image point.
  [in] | O | Gradient orientation for each image point.
  [in] | h | Image height.
  [in] | w | Image width.
  [in] | bin_size | Spatial bin size.
  [in] | n_orients | Number of orientation bins.
  [in] | soft_bin | If true, each pixel can contribute to multiple spatial bins (using bilinear interpolation).
  [out] | H | Gradient histograms.

## gradMag()

void pcl::people::HOG::gradMag | ( | float * | I,
|  | int | h,
|  | int | w,
|  | int | d,
|  | float * | M,
|  | float * | O
| ) |  | const

Compute gradient magnitude and orientation at each location (uses sse).

Parameters

  [in] | I | Image as array of float.
  [in] | h | Image height.
  [in] | w | Image width.
  [in] | d | Image number of channels.
  [out] | M | Gradient magnitude for each image point.
  [out] | O | Gradient orientation for each image point.

## normalization()

void pcl::people::HOG::normalization | ( | float * | H,
|  | int | h,
|  | int | w,
|  | int | bin_size,
|  | int | n_orients,
|  | float | clip,
|  | float * | G
| ) |  | const

Normalize histogram of gradients.

Parameters

  [in] | H | Gradient histograms.
  [in] | h | Image height.
  [in] | w | Image width.
  [in] | bin_size | Spatial bin size.
  [in] | n_orients | Number of orientation bins.
  [in] | clip | Value at which to clip histogram bins.
  [out] | G | Normalized gradient histograms.

## Member Data Documentation

## bin_size_

int pcl::people::HOG::bin_size_

protected

spatial bin size (default = 8)

Definition at line 174 of file hog.h.

## clip_

float pcl::people::HOG::clip_

protected

value at which to clip histogram bins (default = 0.2)

Definition at line 183 of file hog.h.

## h_

int pcl::people::HOG::h_

protected

image height (default = 128)

Definition at line 165 of file hog.h.

## n_channels_

int pcl::people::HOG::n_channels_

protected

image number of channels (default = 3)

Definition at line 171 of file hog.h.

## n_orients_

int pcl::people::HOG::n_orients_

protected

number of orientation bins (default = 9)

Definition at line 177 of file hog.h.

## soft_bin_

bool pcl::people::HOG::soft_bin_

protected

if true, each pixel can contribute to multiple spatial bins (using bilinear interpolation) (default = true)

Definition at line 180 of file hog.h.

## w_

int pcl::people::HOG::w_

protected

image width (default = 64)

Definition at line 168 of file hog.h.

The documentation for this class was generated from the following file:

- pcl/people/hog.h